其他分享
首页 > 其他分享> > codeforces1409 E. Two Platforms(排序,贪心)

codeforces1409 E. Two Platforms(排序,贪心)

作者:互联网

目录:

题意

链接: link.
给出n个点的坐标, 给定两个长度为k的平板. 平板只能水平放置, 且假设放置好平板后所有点开始下落, 问用两个平板最多能接住多少个点.

思路

参考链接: link.
很显然这题的纵坐标给定是没有意义的, 所以我们不需要管纵坐标, 只需要考虑点的横坐标即可.

首先我们应该得对所有的点进行排序, 这样我们可以O(n)的时间枚举每一处可以放置平板的位置. 但是介于是两个平板, 我们需要考虑如何合理放置这两个平板, 不能只照顾其中一个平板. 对于题目而言, 虽然说两个平板可以重叠放置, 但是我们也一定有一种合理的解使得两个平板不重叠时取得最优解. 因此我们不妨从区间右侧开始向区间左侧枚举, res[i]表示可选从第i个点位置开始至第n个点之间, 我们选择最优的放置平板位置时得到的最优解.
这样我们再次枚举O(n)第一个平板的可处位置, 从res中取出此时板2在最优位置时的覆盖数目, 每次贪心取最优即可.

AC代码

#include <bits/stdc++.h>
using namespace std;
#define ll long long
const int N = 2E5 + 10;
int arr[N];
int res[N];
int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--)
    {
        memset(res, 0, sizeof res);
        int n, k;
        cin >> n >> k;
        for (int i = 1; i <= n; i++)
        {
            cin >> arr[i];
        }
        int y;
        for (int i = 1; i <= n; i++)
        {
            cin >> y;
        }
        sort(arr + 1, arr + n + 1);
        for (int i = n; i >= 1; i--)
        {
            int ed = arr[i] + k;
            int index = upper_bound(arr + i, arr + n + 1, ed) - arr;
            index--;
            res[i] = max(res[i + 1], index - i + 1);
        }
        int ans = 0;
        for (int i = 1; i <= n; i++)
        {
            int ed = arr[i] + k;
            int index = upper_bound(arr + i, arr + n + 1, ed) - arr;
            index--;
            ans = max(ans, res[index + 1] + index - i + 1);
        }
        cout << ans << endl;
    }
    //system("pause");
    return 0;
}

标签:index,arr,平板,int,res,Two,cin,Platforms,codeforces1409
来源: https://blog.csdn.net/MoRan0_0/article/details/119187456